#
# These are the rather ugly looking generators separated from the main code for clarity
#


# ::TODO::  
# String.find_method(:new)  [:new, Class]  or [] if none found
# "".find_method(:to_s)  # finds instance methods or signleton [:to_s, Comparable]  [:wow, Singleton]
#
#  String.local_methods  might also be cool!
#  String.inherited_methods as well
#
#
#

class Object
  @@better_installed_methods={}
  @@better_object_valid_methods={}
  
# 
#  Generator :find_def
#  
hash = {}
hash[:type] = :both
hash[:explain] = "CLASS_NAME.find_def # locates owner (class name) of defined instance method"
hash[:code] = "
  def self.BO_METH_NAME(sym)
    return method(sym).owner rescue nil
  end 
  def BO_METH_NAME(sym)
    return method(sym).owner rescue nil
  end 
"  # does not seem to like the <<'CODE' thing ... not sure why ... works everywhere else
   # so use the "" thing instead 
@@better_object_valid_methods[:find_def] = hash  


#
#  Generator  :replaced_methods
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "obj.replaced_methods() # similar to methods but only lists methods replaced by inheritance or overridden by singletons"
hash[:code] = <<'CODE'
  def BO_METH_NAME
    locals = []
    sc = self.class
    methods.each do |item|
      locals.push item if method(item).owner == sc
    end
    outs = []
    singles = singleton_methods
    chain = self.class.ancestors[1..-1]
    chain.each do |item|
      outs += item.instance_methods
    end
    outs_and_locals     = outs & locals
    locals_and_singles  = locals & singles
    singles_and_outs    = outs & singles
    return (outs_and_locals | locals_and_singles | singles_and_outs).sort
  end
CODE
@@better_object_valid_methods[:replaced_methods] = hash


#
#  Generator  :local_methods
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "obj.inherited_methods() # similar to methods but excludes locally defined methods"
hash[:code] = <<'CODE'
  def BO_METH_NAME(include_singles=true)
    rtn = []
    sc = self.class
    methods.each do |item|
      rtn.push item if method(item).owner == sc
    end
    rtn += singleton_methods if include_singles
    return rtn.sort
  end
CODE
@@better_object_valid_methods[:local_methods] = hash


#
#  Generator  :inherited_methods
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "obj.inherited_methods() # similar to methods but excludes locally defined methods"
hash[:code] = <<'CODE'
  def BO_METH_NAME
    rtn = []
    sc = self.class
    methods.each do |item|
      rtn.push item unless method(item).owner == sc
    end
    rtn -= singleton_methods
    return rtn.sort
  end
CODE
@@better_object_valid_methods[:inherited_methods] = hash


#
#  Generator  :comes_from?
#    
hash = {}
hash[:type] = :class
hash[:explain] = "CLASS_NAME.comes_from?(Other) # true if CLASS_NAME is or derives from Other"
hash[:code] = <<'CODE'
  def self.BO_METH_NAME(const)
    ary = ancestors
    rtn = ary.include? const
    return rtn
  end    
CODE
@@better_object_valid_methods[:comes_from? ] =  hash


#
#  Generator  :derives_from?
#    
hash = {}
hash[:type] = :class
hash[:explain] = "CLASS_NAME.derives_from?(Other) # true if CLASS_NAME derives from Other"
hash[:code] = <<'CODE'
  def self.BO_METH_NAME(const)
    ary = ancestors - [self]
    rtn = ary.include? const
    return rtn
  end    
CODE
@@better_object_valid_methods[:derives_from? ] = hash


#
#  Generator  :in?
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "obj.in?(enum) # ex:  3.in? [3,4,5] == true"
hash[:code] = <<'CODE'
  def BO_METH_NAME(enum)
    enum.include? self
  end    
CODE
@@better_object_valid_methods[:in? ] = hash


#
#  Generator  :define_presence_of
#    
hash = {}
hash[:type] = :class
hash[:explain] = "CLASS_NAME.define_presence_of(:meth_name, val=true)\n  # ex:  String.define_presence_of :is_string?\n  ''.is_string?  # true"
hash[:code] = <<'CODE'
  def self.BO_METH_NAME(method_name, value=true)
    Object.class_eval do
      define_method(method_name) do
        return !value
      end  
    end
    class_eval do
      define_method(method_name) do
        return value
      end  
    end
  end # def
CODE
@@better_object_valid_methods[:define_presence_of] = hash 


#
#  Generator  :sort!
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "hash_instance.sort! # forces Hash keys to be sorted in ascending order"
hash[:code] = <<'CODE'
  Hash.class_eval do
    def BO_METH_NAME              
      hash = {}
      sort.each do |pair|
        hash[pair.first]=pair.last
      end
      replace hash
    end
  end
CODE
hash[:rm] = <<'CODE'
  Hash.class_eval do
    undef BO_METH_NAME rescue :never_mind
  end
CODE
@@better_object_valid_methods[:sort!] = hash 


#
#  Generator  :to_literal
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "obj.to_literal # alias for #inspect"
hash[:code] = <<'CODE'
  def BO_METH_NAME
    if respond_to? :inspect
      inspect
    else
      to_s
    end
  end
CODE
@@better_object_valid_methods[:to_literal] = hash 


#
#  Generator  :pluralize
#    
hash = {}
hash[:type] = :class
hash[:explain] = "adds plural versions of include, respond_to?, start_with, etc"
hash[:code] = <<'CODE'
  def self.BO_METH_NAME(prm, alt=nil)
    unless self==Object
      raise "unknown method #{prm.to_sym}" unless instance_methods.include?(prm)
    end  
    if alt.nil?
      sprm = prm.to_s
      if (sprm.include? '_')
        ary = sprm.split('_')
        ary[0] += 's'
        ps = ary.join "_"
      else
        if sprm[-1]=='?'
          ps = sprm[0..(-2)] + 's?'
        elsif sprm[-1]=='!'
          ps = sprm[0..(-2)] + 's!'  
        else
          ps = sprm + 's'
        end
      end
    else
      ps = alt
    end
    cmd = "def #{ps}(*prms)\n#{sprm}(*prms)\nend"
    class_eval cmd
    ps
  end
CODE
@@better_object_valid_methods[:pluralize] = hash 


#
#  Generator  :parent
#    
hash = {}
hash[:type] = :class
hash[:explain] = "finds the parent class not including modules"
hash[:code] = <<'CODE'
  def self.BO_METH_NAME
    return Object if self==Object
    ary = ancestors
    ary[1..(-1)].each do |name|
      next if name.class == Module
      return Object if name==Object
      return name
    end  
  end  
CODE
@@better_object_valid_methods[:parent] = hash


#
#  Generator  :functionize
#    
hash = {}
hash[:type] = :class
hash[:explain] = "creates MyClass() on Kernel level as an alternate constructor or class method"
hash[:code] = <<'CODE'
  def BO_METH_NAME(meth=:new)
    raise "can't redefine #{self}" if Kernel.methods.include? self.to_s.to_sym
    raise "can't redefine #{self}" if self.respond_to? self.to_s.to_sym
    cmd = "def #{self}(*prms,&block); return #{self}.#{meth.to_s}(*prms,&block);end"
    Kernel.class_eval cmd
  end  
CODE
@@better_object_valid_methods[:functionize] = hash


#
#  Generator  :tag
#    
hash = {}
hash[:type] = :instance
hash[:explain] = "creates :tag, :tag=, :tag?, untag, :tag!"
hash[:code] = <<'CODE'
  def BO_METH_NAME
    nil || @bo_BO_METH_NAME
  end
  def BO_METH_NAME!
    @bo_BO_METH_NAME = true
  end  
  def unBO_METH_NAME
    @bo_BO_METH_NAME = false
  end
  def BO_METH_NAME?
    return nil != (@bo_BO_METH_NAME || nil)
  end
  def BO_METH_NAME=(prm)
    @bo_BO_METH_NAME=prm
  end    
CODE
hash[:rm] = <<'CODE'
  undef BO_METH_NAME rescue :never_mind
  undef unBO_METH_NAME rescue :never_mind
  undef BO_METH_NAME? rescue :never_mind
  undef BO_METH_NAME! rescue :never_mind
  undef BO_METH_NAME= rescue :never_mind
CODE
@@better_object_valid_methods[:tag] = hash


#
#  Generator  :create_tag
#
hash = {}
hash[:type] = :class
hash[:explain] = "creates multiple named tags similar to :tag"
hash[:code] = <<'CODE'
  def self.BO_METH_NAME(tag_name)
    class_eval do
      meth = tag_name.to_s
      
      define_method meth.to_sym do
        @boh_BO_METH_NAME ||= {}
        nil || @boh_BO_METH_NAME[tag_name]
      end
      define_method (meth+"!").to_sym do
        @boh_BO_METH_NAME ||= {}
        @boh_BO_METH_NAME[tag_name] = true
      end
      define_method ("un" + meth).to_sym do
        @boh_BO_METH_NAME ||= {}
        @boh_BO_METH_NAME[tag_name] = false
      end
      define_method (meth+"?").to_sym do
        @boh_BO_METH_NAME ||= {}
        return nil != (@boh_BO_METH_NAME[tag_name] || nil)
      end
      define_method (meth+"=").to_sym do |prm|
        @boh_BO_METH_NAME ||= {}
        @boh_BO_METH_NAME[tag_name]=prm
      end      
    end
    tag_name
  end
CODE
@@better_object_valid_methods[:create_tag] = hash


#
#  Generator  :push_unique
#
hash = {}
hash[:type] = :instance
hash[:explain] = "creates #push_unique method on Array"
hash[:code] = <<'CODE'
  Array.class_eval do
    def BO_METH_NAME(item)
      push item unless self.include? item
      self
    end
 end   
CODE
hash[:rm] = <<'CODE'
  Array.class_eval do
    undef BO_METH_NAME
  end
CODE
@@better_object_valid_methods[:push_unique] = hash


#
#  Generator  :delete_many_at
#
hash = {}
hash[:type] = :instance
hash[:explain] = "creates #delete_many_at method on Array. Same as #delete_at, but also allows a list of arguments"
hash[:code] = <<'CODE'
  Array.class_eval do
    def BO_METH_NAME(*list)
      rtn = []
      list = list.first if list.first.kind_of? Array   # must delete right-to_left
      ran = []
      ary = []
      num = []
      list.each do |elm|
        if elm.kind_of? Range
          ran.concat elm.to_a
        elsif elm.kind_of? Array
          ary.concat elm
        else
          num.push elm     
        end
      end
      grp = (ran|ary|num).sort.reverse   
      grp.each do |idx|
        rtn.push(delete_at(idx))
      end
      return rtn.reverse
    end
 end   
CODE
hash[:rm] = <<'CODE'
  Array.class_eval do
    undef BO_METH_NAME
  end
CODE
@@better_object_valid_methods[:delete_many_at] = hash


#
#  Generator  :many_at
#
hash = {}
hash[:type] = :instance
hash[:explain] = "creates #many_at method on Array. Same as #at but allows a list of arguments"
hash[:code] = <<'CODE'
  Array.class_eval do
    def BO_METH_NAME(*list)
      rtn = []
      list = list.first if list.first.kind_of? Array   # must delete right-to_left
      list.each do |elm|
        if elm.kind_of? Range
          rtn.concat elm.to_a
        elsif elm.kind_of? Array
          rtn.concat elm
        else
          rtn.push elm     
        end
      end
      return rtn
    end
 end   
CODE
hash[:rm] = <<'CODE'
  Array.class_eval do
    undef BO_METH_NAME
  end
CODE
@@better_object_valid_methods[:many_at] = hash


#
#  Generator  tripleize
#
hash = {}
hash[:type] = :class
hash[:explain] = "defines === to mean: left.include? right or your block result" 
hash[:code] = <<'CODE'
  def self.BO_METH_NAME(&proc)
    if proc.nil?
      def === (elm)
        self.include? elm
      end  
    else
      @proc_tripleize = proc
      def === (elm)
        self.class.instance_variable_get(:@proc_tripleize).call(self,elm)
      end
    end
  end
CODE
@@better_object_valid_methods[:tripleize] = hash


#
#  Generator  include_many?
#
hash = {}
hash[:type] = :instance
hash[:explain] = "calls include? to check for multiple items"
hash[:code] = <<'CODE'
  def BO_METH_NAME(*items)
    items = items.first if items.first.kind_of? Array
    items.each do |item|
      return false unless self.include? item
    end
    true
  end
CODE
@@better_object_valid_methods[:include_many?] = hash


#
#  Generator  include_any?
#
hash = {}
hash[:type] = :instance
hash[:explain] = "calls include? to check for multiple items"
hash[:code] = <<'CODE'
  def BO_METH_NAME(*items)
    items = items.first if items.first.kind_of? Array
    items.each do |item|
      return true if self.include? item
    end
    false
  end
CODE
@@better_object_valid_methods[:include_any?] = hash


#
#  Generator  cvar
#
hash = {}
hash[:type] = :both
hash[:explain] = "cvar reads and writes class variables from instance or class"
hash[:code] = <<'CODE'
  def BO_METH_NAME(sym)
    self.class.instance_variable_get("@#{sym}".to_sym)
  end
  def BO_METH_NAME!(sym,dat)
    self.class.instance_variable_set("@#{sym}".to_sym,dat)
  end
  def self.BO_METH_NAME(sym)
    instance_variable_get("@#{sym}".to_sym)
  end
  def self.BO_METH_NAME!(sym,dat)
    instance_variable_set("@#{sym}".to_sym,dat)
  end
CODE
@@better_object_valid_methods[:cvar] = hash


#
#  Generator  dup_safe
#
hash = {}
hash[:type] = :instance
hash[:explain] = "dup if possible else self"
hash[:code] = <<'CODE'
  def BO_METH_NAME
    dup rescue self
  end
CODE
@@better_object_valid_methods[:dup_safe] = hash

end
